#######################################################
#
# BATTLESHIP
#
# Partners:
#
#
# Number   Type                 Size
# 1        Aircraft Carrier     5
# 1        Battleship           4
# 1        Submarine            3
# 2        Destroyer            3
# 2        Patrol Boat          2

import random
from urllib import urlopen

# the grid is the playing field
grid = []

# ships is an array of ships. Each ship has a name like A1. The letter part
# of the name refers to the type of ship (A = Aircraft Carrier). The number part
# represents the ship number. So A1, means the first ship is an aircraft carrier.
# The second part of the ship array is the size of the ship. So, A1 is of size 5.
ships = [['A1', 5],
         ['B2', 4],
         ['S3', 3],
         ['D4', 3],
         ['D5', 3],
         ['P6', 2],
         ['P7',2]]

curShips = []

    ####
   ####    MAKE THE INITIAL PLAYING GRID
  ####
 ####      This generates a random board
####
###        You don't need to change anything here.



def check_position(row, column, direction, size):
    if direction == 'vertical':
       if row + size < 10:
               for i in range(row, row + size):
                   if grid[i][column] != 'o':
                       return False
               return True
       else:
           return False
    else:
        if column + size < 10:
            for i in range(column, column + size):
                if grid[row][i] != 'o':
                    return False
            return True
        else:
            return False

def add_ship(shipName, size):
    """add a ship to the grid"""
    location = (0,0)
    positionGood = False
    while not positionGood:
       # first pick a random location
       row = random.randint(0,9)
       column = random.randint(0,9)
       if (random.randint(1,2) == 1):
           direction = 'vertical'
       else:
           direction = 'horizontal'
       positionGood = check_position(row, column, direction, size)
    # now have a good position so add ship
    if direction == 'vertical':
        for i in range(row, row + size):
            grid[i][column] = shipName
    else:
        for i in range(column, column + size):
            grid[row][i] = shipName
    
    

def create_game():
    # first I am going to create the 10 x 10 grid
    row = ['o', 'o', 'o', 'o', 'o', 'o', 'o', 'o', 'o', 'o']
    for i in range(10):
        grid.append(list(row))
        
    # now add ships to grid (randomly)
    for i in range(len(ships)):
       size = ships[i][1]
       add_ship(ships[i][0], size)
    curShips = list(ships)
    return curShips

    ####
   ####  END OF CODE TO CREATE BOARD
  ####
 ####

def draw_grid():
    print "    0   1   2   3   4   5   6   7   8   9"
    letters = ['A', 'B', 'C', "D", "E", "F", "G", "H", "I", "J"]
    rowNum = 0
    for row in grid:
        line = letters[rowNum]
        for cell in row:
            line += "%4s" % cell
        print line + '\n'
        rowNum += 1


    ####
   ####   YOU NEED TO WRITE THE FOLLOWING THREE PROCEDURES
  ####
 ####


def draw_player_grid():
    """This will be based on the draw_grid procedure above.
    It should hide the location of the ships"""
    return "TODO" # remove this line


def isWin(curShips):
    """This function should return True if the person won the game
    and False otherwise"""
    return True

def move(curShips):
    """This procedure should process one move of the game.
    1) it should display the board
    2) it should get input from the user (the move) in the form like B5
    3) it should determine if there is a hit or miss (and print out 'HIT' or 'MISS'
    4) it should update the grid
    5) if necessary, it should update the curShips array
    6) if a ship has been sunk it should report that"""
    

def play():
    curShips = create_game()
    while  not isWin(curShips):
        move(curShips)
        

